/*
 * SpeechPlayer.settingsForm
 * author: Makoto Yoshida
 * version: 2008/6/30
 */

using SpeechLib;
using System;
using System.Windows.Forms;

namespace SpeechPlayer
{
    public partial class settingsForm : Form
    {
        private SpeechPlayer.mainForm theMainForm;

        public settingsForm()
        {
            this.InitializeComponent();
        }

        private void settingsForm_Load(object sender, EventArgs e)
        {
            theMainForm = (SpeechPlayer.mainForm)this.Owner;
            ISpeechObjectTokens sot = theMainForm.theSpVoice.GetVoices(string.Empty, string.Empty);
            for (int i = 0; i < sot.Count; i++)
            {
                this.voiceListBox.Items.Add(sot.Item(i).GetDescription(0));
            }
            bindVoice();
        }

        private void voiceListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            SpeechPlayer.Properties.Settings.Default.Voice =
                (string)this.voiceListBox.SelectedItem;
            bindVoice();
        }

        private void bindVoice()
        {
            string s = SpeechPlayer.Properties.Settings.Default.Voice;
            theMainForm.setVoice(s);
            this.voiceListBox.SelectedItem = (object)s;
            this.theToolTip.SetToolTip(this.voiceListBox, s);
        }

        private void rateNumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            // DataBindings is not immediate.
            // -10 to 10
            theMainForm.theSpVoice.SetRate((int)this.rateNumericUpDown.Value);
        }

        private void volumeNumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            // DataBindings is not immediate.
            // 0 to 100
            theMainForm.theSpVoice.SetVolume((ushort)this.volumeNumericUpDown.Value);
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            SpeechPlayer.Properties.Settings.Default.Save();
            //this.okButton.DialogResult = DialogResult.OK;
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            SpeechPlayer.Properties.Settings.Default.Reload();
            bindVoice();
            theMainForm.theSpVoice.SetRate((int)SpeechPlayer.Properties.Settings.Default.Rate);
            theMainForm.theSpVoice.SetVolume(
                (ushort)SpeechPlayer.Properties.Settings.Default.Volume);
            //this.cancelButton.DialogResult = DialogResult.Cancel;
        }
    }
}